unit math3d;
{
Cut down version of Math3d.Pas
}

interface

type TVector3f = record
  X, Y, Z : single;
end;

type TVector3i = record
  X, Y, Z : integer;
end;

type TVector3b = record
  R, G, B : byte;
end;

type TVector3b2 = record
  X, Y, Z : byte;
end;

type TVector3si = record
  X, Y, Z : smallint;
end;

type TVector3l = record
  X, Y, Z : longword;
end;

type TVector2f = record
  X, Y : single;
end;

type TVector2i = record
  X, Y : Integer;
end;

Type TVector4f = record
  X, Y, Z, Alpha : single;
end;

const
  M_PI = 3.1415926535897932384626433832795;		// matches value in gcc v2 math.h
  M_TWO_PI = 6.283185307179586476925286766559;
  M_180_PI = 57.295779513082320876798154814105;
  M_PI_180 = 0.017453292519943295769236907684886;

function SubtractVector(v1, v2 : TVector3f) : TVector3f;
function SetVector(x, y, z : single) : TVector3f;
function Normalize(var v : TVector3f) : single;

implementation

function SubtractVector(v1, v2 : TVector3f) : TVector3f;
begin
  with result do begin
    x := v1.x - v2.x;
    y := v1.y - v2.y;
    z := v1.z - v2.z;
  end;
end;

function SetVector(x, y, z : single) : TVector3f;
begin
  result.x := x;
  result.y := y;
  result.z := z;
end;

function Normalize(var v : TVector3f) : single;
var l : single;
begin
  l := sqrt(v.x*v.x+v.y*v.y+v.z*v.z);

  if (l > 0) then begin
    v.x := v.x/l;
    v.y := v.y/l;
    v.z := v.Z/l;
  end;
  result := l;  
end;

end.
