// A much nicer one than VXLSE III
unit ThreeDView_Engine;

interface

Uses Windows,SysUtils,Graphics,Math3d,OpenGL15,dialogs,Classes,ComCtrls, Helios_Shader_System, Helios_Timer,{$IfDef HELIOS_APP}Q3BSP{$Else}Helios_Basic{$EndIf};

type
PStatusBar = ^TStatusBar;

var
oglloaded : boolean = false;
DebugMode : boolean = false;
MVEnabled : boolean = true;
ParticleLoaded : boolean = false;

XRotB,YRotB : boolean;
BGColor,FontColor : TVector3f;

FPS : single;
base : GLuint;		                	// Base Display List For The Font Set
dc  : HDC;     // Device Context
FFrequency : int64;
FoldTime : int64;    // last system time

rc : HGLRC;    // Rendering Context
ElapsedTime, DemoStart, LastTime : DWord;
YRot, XRot, XRot2, YRot2     : glFloat;    // Y Rotation
Depth  : glFloat;
Xcoord, Ycoord, Zcoord : Integer;
MouseButton : Integer;
MainViewWidth,MainViewHeight : integer;

TakeScreenShot : boolean = false;
Take360DAnimation : Boolean = false;
TakeAnimation : Boolean = false;
CaptureAnimation : Boolean = false;

Form_StatusBar : PStatusBar;

PID : Integer = -1;

Procedure ResizeMainView(Width,Height : integer);
procedure DrawFrames;
Procedure Init(Handle : HWND);

procedure glBindTexture(target: GLenum; texture: GLuint); stdcall; external opengl32;
{procedure glTexCoordPointer(size : GLint; _type : GLenum; stride : GLsizei; const pointer : GLvoid) stdcall; external opengl32;}

Function TColorToTVector3f(Color : TColor) : TVector3f;
Function TVector3fToTColor(Vector3f : TVector3f) : TColor;

procedure ScreenShot(Filename : string);
procedure ScreenShotJPG(Filename : string; Compression : integer);
function ScreenShot_BitmapResult : TBitmap;

implementation

Uses Forms,Textures,JPEG,FormMain;

procedure BuildFont;			                // Build Our Bitmap Font
var font: HFONT;                	                // Windows Font ID
    gmf : array [0..255] of GLYPHMETRICSFLOAT;		// Address Buffer For Font Storage
begin
  base := glGenLists(256);       	                // Storage For 96 Characters

  SelectObject(DC, font);		       	        // Selects The Font We Want


  font := CreateFont(9, 0,0,0, FW_NORMAL, 0, 0, 0, OEM_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY	, FF_DONTCARE + DEFAULT_PITCH, 'Terminal');
  SelectObject(DC, font);
  wglUseFontBitmaps(DC, 0, 127, base);
end;

procedure KillFont;     		                // Delete The Font
begin
  glDeleteLists(base, 256); 		                // Delete All 96 Characters
end;

procedure glPrint(text : pchar);	                // Custom GL "Print" Routine
begin
  if (text = '') then   			        // If There's No Text
          Exit;					        // Do Nothing

  glPushAttrib(GL_LIST_BIT);				// Pushes The Display List Bits
  glListBase(base);					// Sets The Base Character
  glCallLists(length(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
  glPopAttrib();								// Pops The Display List Bits
end;


procedure ScreenShot(Filename : string);
var
  buffer: array of byte;
  i, c, temp: integer;
  f: file;
  t, FN, FN2, FN3 : string;
  SSDir : string;
begin
  // create the scrnshots directory if it doesn't exist
  SSDir := extractfiledir(Paramstr(0))+'\ScreenShots\';
  FN2 := extractfilename(Filename);
  FN2 := copy(FN2,1,length(FN2)-length(Extractfileext(FN2)));

 // sys_mkdir
  {$I-}
  CreateDir(SSDir);
//  MkDir(SSDir);
  {$I+}
  FN := SSDir+FN2;

  for i := 0 to 999 do
  begin
  t := inttostr(i);
  if length(t) < 3 then
  t := '00'+t
  else
  if length(t) < 2 then
  t := '0'+t;
  if not fileexists(FN+'_'+t+'.bmp') then
  begin
  FN3 := FN+'_'+t+'.bmp';
  break;
  end;
  end;

  if FN3 = '' then
  begin
    exit;
  end;

  ScreenShot_BitmapResult.SaveToFile(FN3);
end;

procedure ScreenShotJPG(Filename : string; Compression : integer);
var
  buffer: array of byte;
  i, c, temp: integer;
  f: file;
  t, FN, FN2, FN3 : string;
  SSDir : string;
  JPEGImage: TJPEGImage;
  Bitmap : TBitmap;
begin
  // create the scrnshots directory if it doesn't exist
  SSDir := extractfiledir(Paramstr(0))+'\ScreenShots\';
  FN2 := extractfilename(Filename);
  FN2 := copy(FN2,1,length(FN2)-length(Extractfileext(FN2)));

 // sys_mkdir
  {$I-}
  CreateDir(SSDir);
//  MkDir(SSDir);
  {$I+}
  FN := SSDir+FN2;

  for i := 0 to 999 do
  begin
  t := inttostr(i);
  if length(t) < 3 then
  t := '00'+t
  else
  if length(t) < 2 then
  t := '0'+t;
  if not fileexists(FN+'_'+t+'.jpg') then
  begin
  FN3 := FN+'_'+t+'.jpg';
  break;
  end;
  end;

  if FN3 = '' then
  begin
    exit;
  end;
  Bitmap := TBitmap.Create;
  Bitmap := ScreenShot_BitmapResult;
  JPEGImage := TJPEGImage.Create;
  JPEGImage.Assign(Bitmap);
  JPEGImage.CompressionQuality := 100-Compression;
  JPEGImage.SaveToFile(FN3);
  Bitmap.Free;
  JPEGImage.Free;
end;

function ScreenShot_BitmapResult : TBitmap;
var
  buffer: array of byte;
  x,y, i: integer;
  Bitmap : TBitmap;
  Stream : TMemoryStream;
  WW : integer;
begin
  {
  WW forces the thing to Get an image that has an even width, even when its ment to b odd
  this fixes the prob with an odd width.
  }
  if MainViewWidth div 2 = MainViewWidth / 2 then
  WW := MainViewWidth
  else
  WW := MainViewWidth+1;

  SetLength(buffer, (WW * MainViewHeight * 3)+1);

  glReadPixels(0, 0, WW, MainViewHeight, GL_RGB, GL_UNSIGNED_BYTE, Pointer(Cardinal(buffer) {+ 18}));

  i := 0;
  Bitmap := TBitmap.Create;
  Bitmap.Canvas.Brush.Color := TVector3fToTColor(BGColor);
  Bitmap.Width := MainViewWidth;
  Bitmap.Height := MainViewHeight;
  for y := 1 to MainViewHeight do
  for x := 1 to WW do
  begin
  if x <= MainViewWidth then
  Bitmap.Canvas.Pixels[x-1,MainViewHeight-y] := RGB(buffer[(i*3)],buffer[(i*3)+1],buffer[(i*3)+2]);
  inc(i);
  end;
  finalize(buffer);
  Result := Bitmap;
end;

Function TColorToTVector3f(Color : TColor) : TVector3f;
begin

Result.X := GetRValue(Color) / 255;
Result.Y := GetGValue(Color) / 255;
Result.Z := GetBValue(Color) / 255;

end;

Function TVector3fToTColor(Vector3f : TVector3f) : TColor;
begin

Result := RGB(trunc(Vector3f.X*255),trunc(Vector3f.Y*255),trunc(Vector3f.Z*255));

end;

Function CleanVCCol(Color : TColor) : TVector3f;
Var
T : TVector3f;
begin

T.X := GetRValue(Color);
T.Y := GetGValue(Color);
T.Z := GetBValue(Color);

If T.X > 255 then
T.X := 255;

If T.X < 0 then
T.X := 0;

If T.Y > 255 then
T.Y := 255;

If T.Y < 0 then
T.Y := 0;

If T.Z > 255 then
T.Z := 255;

If T.Z < 0 then
T.Z := 0;

T.X := T.X / 255;
T.Y := T.Y / 255;
T.Z := T.Z / 255;

Result := T;

end;

Function CleanV3fCol(Color : TVector3f) : TVector3f;
Var
T : TVector3f;
begin

T.X := Color.X;
T.Y := Color.Y;
T.Z := Color.Z;

If T.X > 255 then
T.X := 255;

If T.X < 0 then
T.X := 0;

If T.Y > 255 then
T.Y := 255;

If T.Y < 0 then
T.Y := 0;

If T.Z > 255 then
T.Z := 255;

If T.Z < 0 then
T.Z := 0;

T.X := T.X / 255;
T.Y := T.Y / 255;
T.Z := T.Z / 255;

Result := T;

end;

function CleanAngle(Angle : single) : single;
begin
Result := Angle;

If result < 0 then
Result := 360 + Result;

If result > 360 then
Result := Result - 360;
end;

Procedure DrawShaderSquare(ShaderId : Integer; X,Y,Width,Height : Integer);
var shader : TShader;
    i,j, texId : integer;
    V : Array [0..5] of TBSPVertex;
    c : Extended;
begin
glLoadIdentity;
  try
  shader := ShaderManager[shaderId];

  V[0].Position := SetVector(X,Y,0);
  V[1].Position := SetVector(X+Width,Y,0);
  V[2].Position := SetVector(X+Width,Y+Height,0);

  V[3].Position := SetVector(X,Y+Height,0);
  V[4].Position := SetVector(X,Y,0);
  V[5].Position := SetVector(X+Width,Y+Height,0);

  for j := 0 to 5 do
  V[j].Normal := SetVector(0,0,0);

    SetDefaults;
    glEnable(GL_TEXTURE_2D);
    glDisable(GL_DEPTH_TEST);
    glPushAttrib(GL_ALL_ATTRIB_BITS);
    glMatrixMode(GL_PROJECTION);
    glPushMatrix;
    glLoadIdentity;

    glOrtho(0, SCREEN_WIDTH, 0, SCREEN_HEIGHT, -1, 1);                                    // Set Up An Ortho Screen
    glMatrixMode(GL_MODELVIEW);                                                   // Select The Modelview Matrix
    glPushMatrix();

    ShaderManager.SetVertexCoords_Shader(shaderId,6,V);

  if shader.numOfLayers > 0 then begin
    for i := 0 to shader.numOfLayers-1 do begin

    if (ShaderManager[shaderId].Layers[i].numOfrgbGen > 0) then begin

        V[0].Color[0] := 127;
        V[0].Color[1] := 127;
        V[0].Color[2] := 127;
        V[0].Color[3] := 255;

        ShaderManager.SetVertexColors_Shader(shaderId,i,1,V);
        glColor3f(colorBuffer[0][0]/255,colorBuffer[0][1]/255,colorBuffer[0][2]/255)
      end
      else
      glColor3f(0.5,0.5,0.5);

      V[0].TextureCoord.X := 0;
      V[0].TextureCoord.Y := 0;
      V[1].TextureCoord.X := 1;
      V[1].TextureCoord.Y := 0;
      V[2].TextureCoord.X := 1;
      V[2].TextureCoord.Y := 1;

      V[3].TextureCoord.X := 0;
      V[3].TextureCoord.Y := 1;
      V[4].TextureCoord.X := 0;
      V[4].TextureCoord.Y := 0;
      V[5].TextureCoord.X := 1;
      V[5].TextureCoord.Y := 1;

      ShaderManager.SetTextureCoordinates_Shader(shaderId, i,6,V);

      texId := shader.Layers[i].TextureId[shader.Layers[i].curTexture];

      If texID < 1 then
      TexId := shader.qerId;
      
      glBindTexture(GL_TEXTURE_2D, texId);

      ShaderManager.SetState(shaderId, i );
      glDisable(GL_CULL_FACE);

    glBegin(GL_TRIANGLES);

    for j := 0 to 5 do
    begin
    glTexCoord2f(V[j].TextureCoord.X, V[j].TextureCoord.Y);
    glVertex3f(V[j].Position.X, V[j].Position.Y, V[j].Position.Z);
    end;

    glEnd;

    end;
  end;

    glPopMatrix;
    glMatrixMode(GL_PROJECTION);
    glPopMatrix;
    glPopAttrib;
    glMatrixMode(GL_MODELVIEW);

    glDisable(GL_TEXTURE_2D);
  SetDefaults;
  except
    lastError := glGetError();
    lastErrorString := gluErrorString(lastError);
    {$IfDef HELIOS_CONSOLE}
    Cons.AddIfDifferent('RenderSquareShader: ' + lastErrorString + ' ShaderID:' + inttostr(shaderId));
    {$EndIf}
  end;

end;

procedure glDraw(); // Main Thing, Draws World
var
x,Shader : integer;
Scale,Rotation,Perspective,Position : TVector3f;
begin
//  if (not Frm3DPReview.Showing) then exit;
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);    // Clear The Screen And The Depth Buffer

  if (not MVEnabled) then
  begin
 // glClearColor(0, 0, 0, 1.0);
  Exit;
  end
  else
  glClearColor(BGColor.X, BGColor.Y, BGColor.Z, 1.0);

  if XRotB then
  XRot := XRot + XRot2;

  if YRotB then
  YRot := YRot + YRot2;

  If gtimer <> nil then
  gtimer.Refresh;

  XRot := CleanAngle(XRot);
  YRot := CleanAngle(YRot);
  Shader := ShaderManager.IndexOf('SHADERTEST');

  If Shader > -1 then
  DrawShaderSquare(Shader,(SCREEN_WIDTH div 2)-150,(SCREEN_HEIGHT div 2)-150,300,300);

end;


procedure DrawFrames;
var tmp : int64;
    t2 : double;
begin
  if not oglloaded then exit;

  LastTime :=ElapsedTime;
  ElapsedTime :=GetTickCount() - DemoStart;     // Calculate Elapsed Time
  ElapsedTime :=(LastTime + ElapsedTime) DIV 2; // Average it out for smoother movement

  QueryPerformanceCounter(tmp);
  t2 := tmp-FoldTime;
  FPS := t2/FFrequency;
  FoldTime := TMP;
  FPS := 1/FPS;

  glDraw();                         // Draw the scene
  SwapBuffers(DC);                  // Display the scene
end;

Procedure ResizeMainView(Width,Height : integer);
begin
MainViewWidth := Width;
MainViewHeight := Height;

glResizeWnd(MainViewWidth,MainViewHeight);
  {
  glClearColor(BGColor.X, BGColor.Y, BGColor.Z, 1.0);
  glClearDepth(1.0);                       // Depth Buffer Setup

  glViewport(0, 0, MainViewWidth, MainViewHeight);    // Set the viewport for the OpenGL window
  glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
  glLoadIdentity();                   // Reset View
  gluPerspective(45.0, MainViewWidth/MainViewHeight, 1.0, 500.0);  // Do the perspective calculations. Last value = max clipping depth

  glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix  }
end;

Procedure Init(Handle : HWND);
var
i : integer;
pfd : TPIXELFORMATDESCRIPTOR;
pf  : Integer;
begin

InitOpenGL; // Don't forget, or first gl-Call will result in an access violation! exit;

  // OpenGL initialisieren
  dc:=GetDC(Handle);
  h_DC := Dc;

  BGColor   := TColorToTVector3f(RGB(40,111,162));
  FontColor := SetVector(1,1,1);

  // PixelFormat
  pfd.nSize:=sizeof(pfd);
  pfd.nVersion:=1;
  pfd.dwFlags:=PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or 0;
  pfd.iPixelType:=PFD_TYPE_RGBA;      // PFD_TYPE_RGBA or PFD_TYPEINDEX
  pfd.cColorBits:=32;
  pfd.cStencilBits := 8;
  
  pf :=ChoosePixelFormat(dc, @pfd);   // Returns format that most closely matches above pixel format
  SetPixelFormat(dc, pf, @pfd);

  rc :=wglCreateContext(dc);    // Rendering Context = window-glCreateContext
  wglMakeCurrent(dc,rc);        // Make the DC (Form1) the rendering Context

  ActivateRenderingContext(DC, RC);


  glEnable(GL_TEXTURE_2D);                     // Enable Texture Mapping
  glClearColor(BGColor.X, BGColor.Y, BGColor.Z, 1.0);
  glShadeModel(GL_SMOOTH);                 // Enables Smooth Color Shading
  glClearDepth(1.0);                       // Depth Buffer Setup
  glEnable(GL_DEPTH_TEST);                 // Enable Depth Buffer
  glDepthFunc(GL_LESS);		           // The Type Of Depth Test To Do

  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   //Realy Nice perspective calculations

  xRot :=0;
  yRot :=0;
  Depth :=-90;

  oglloaded := true;

  SCREEN_WIDTH := MainViewWidth;
  SCREEN_HEIGHT:= MainViewHeight;

  InitiateHelios(Extractfiledir(ParamStr(0)),'','');
  glResizeWnd(MainViewWidth,MainViewHeight);
  UseCameraByMouse := false;

  Randomize;
end;


begin

end.
